package com.dsic.gj_erp.controller;


import com.alibaba.fastjson.JSONObject;
import com.dsic.gj_erp.annotation.AuthFunction;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.sy.*;
import com.dsic.gj_erp.service.sy.SYService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

@Api(tags = "系统管理")
@RestController
@RequestMapping(value = "/api/sy", method= RequestMethod.POST)
public class SYController {

    @Autowired
    SYService syService;

//    @Autowired
//    MpZzdwjbbService mpZzdwjbbService;
//    @Autowired
//    QcJyxmpMapper qcJyxmpMapper;


    //@AuthFunction(XTMC = "系统安全",MKMC = "用户管理",GNMC = "工作组维护",XTBM = "SY",CKDM = "w_gzzdy")

    @ApiOperation(value = "获取工作组列表")
    @RequestMapping(value = "/getWorkGroupList")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "yhdm", value = "用户代码", required = false, paramType = "query", dataType = "String"),
    })
    public ResultBean getWorkGroupList(@RequestBody Map<String, Object> paramMap) {
        String yhdm = (String) paramMap.get("yhdm");
//        return new ResultBean(syService.getWorkGroupList(yhdm));
        return new ResultBean();
    }

    @ApiOperation(value = "添加工作组")
    @RequestMapping(value = "/addWorkGroup")
    public ResultBean addWorkGroup(@RequestBody Syworkgp syworkgp) {
        return new ResultBean(syService.addWordGroup(syworkgp));
    }

    @ApiOperation(value = "删除工作组")
    @RequestMapping(value = "/deleteWorkGroup")
    public ResultBean deleteWorkGroup(@RequestBody Syworkgp syworkgp) {
        syService.deleteWorkGroup(syworkgp);
        return new ResultBean();
    }

    @ApiOperation(value = "更新工作组")
    @RequestMapping(value = "/updateWorkGroup")
    public ResultBean updateWorkGroup(@RequestBody Syworkgp[] syworkgp) {
        syService.updateWorkGroup(syworkgp[0], syworkgp[1]);
        return new ResultBean();
    }

    @ApiOperation(value = "获取用户列表")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "gwdm", value = "工作组代码", required = false, paramType = "query", dataType = "String"),
            @ApiImplicitParam(name = "sort", value = "排序方式", required = false, paramType = "query", dataType = "Integer" ,defaultValue = "0"),
    })
    @AuthFunction(CKDMS = {"w_gzzdy", "Yhgl"})
    @RequestMapping(value = "/getUserList")
    public ResultBean getUserList(@RequestBody Map<String, Object> paramMap) {
        String gwdm = (String) paramMap.get("gwdm");
        Integer sort = paramMap.get("sort") == null ? 0 : (Integer) paramMap.get("sort");
        return new ResultBean(syService.getUserList(gwdm, sort));
    }

    @ApiOperation(value = "根据菜单功能获取用户列表")
    @RequestMapping(value = "/getUserListByFunc")
    public ResultBean getUserListByFunc(@RequestBody Syifrp syifrp) {
        return new ResultBean(syService.getUserListByFunc(syifrp));
    }

    @ApiOperation(value = "添加用户信息")
    @RequestMapping(value = "/addUser")
    public ResultBean addUser(@RequestBody Syuserp syuserp) {
        syService.addUser(syuserp);
        return new ResultBean();
    }

    @ApiOperation(value = "删除用户信息")
    @RequestMapping(value = "/deleteUser")
    public ResultBean deleteUser(@RequestBody Syuserp syuserp) {
        syService.deleteUser(syuserp);
        return new ResultBean();
    }

    @ApiOperation(value = "更新用户信息")
    @RequestMapping(value = "/updateUser")
    public ResultBean updateUser(@RequestBody Syuserp syuserp) {
        syService.updateUser(syuserp);
        return new ResultBean();
    }

    @ApiOperation(value = "添加用户到工作组")
    @RequestMapping(value = "/addWorkGroupUser")
    public ResultBean addWorkGroupUser(@RequestBody List<Syuirp> syuirp) {
        syService.addWorkGroupUser(syuirp);
        return new ResultBean();
    }

    @ApiOperation(value = "从工作组删除用户")
    @RequestMapping(value = "/deleteWorkGroupUser")
    public ResultBean deleteWorkGroupUser(@RequestBody List<Syuirp> syuirp) {
        syService.deleteWorkGroupUser(syuirp);
        return new ResultBean();
    }

    @ApiOperation(value = "获取权限分组列表")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "gwdm", value = "工作组代码", required = false, paramType = "query", dataType = "String",defaultValue = ""),
    })
    @RequestMapping(value = "/getFzList")
    public ResultBean getFzqxList(@RequestBody Map<String, Object> paramMap) {
        String gwdm = (String) paramMap.get("gwdm");
        return new ResultBean(syService.getFzqxList(gwdm));
    }

    @ApiOperation(value = "添加权限分组到工作组")
    @RequestMapping(value = "/addWorkGroupFz")
    public ResultBean addWorkGroupFz(@RequestBody List<Syigrp> syigrp) {
        syService.addWorkGroupFz(syigrp);
        return new ResultBean();
    }

    @ApiOperation(value = "从工作组删除分组权限")
    @RequestMapping(value = "/deleteWorkGroupFz")
    public ResultBean deleteWorkGroupFz(@RequestBody List<Syigrp> syigrp) {
        syService.deleteWorkGroupFz(syigrp);
        return new ResultBean();
    }

    @ApiOperation(value = "获取子系统权限")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "gwdm", value = "工作组代码", required = false, paramType = "query", dataType = "String",defaultValue = ""),
    })
    @RequestMapping(value = "/getZxtList")
    public ResultBean getZxtList(@RequestBody Map<String, Object> paramMap) {
        String gwdm = (String) paramMap.get("gwdm");
        return new ResultBean(syService.getZxtList(gwdm));
    }

    @ApiOperation(value = "添加子系统权限到工作组")
    @RequestMapping(value = "/addWorkGroupZxt")
    public ResultBean addWorkGroupZxt(@RequestBody List<Syimrp> syismrp) {
        syService.addWorkGroupZxt(syismrp);
        return new ResultBean();
    }

    @ApiOperation(value = "从工作组删除子系统权限")
    @RequestMapping(value = "/deleteWorkGroupZxt")
    public ResultBean deleteWorkGroupZxt(@RequestBody List<Syimrp> syimrp) {
        syService.deleteWorkGroupZxt(syimrp);
        return new ResultBean();
    }

    @ApiOperation(value = "获取用户综合编码")
    @RequestMapping(value = "/getUserZHBM")
    public ResultBean getUserZHBM() {
        return new ResultBean(syService.getUserZHBM());
    }


    @ApiOperation(value = "获取菜单功能")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "gwdm", value = "工作组代码", required = false, paramType = "query", dataType = "String",defaultValue = ""),
    })
    @RequestMapping(value = "/getFuncList")
    public ResultBean getFuncList(@RequestBody Map<String, Object> paramMap) {
        Integer type = (Integer) paramMap.get("type");
        String gwdm = (String) paramMap.get("gwdm");
        return new ResultBean(syService.getFuncList(type, gwdm));
    }

    @ApiOperation(value = "添加功能菜单")
    @RequestMapping(value = "/addFunc")
    public ResultBean addFunc(@RequestBody Syfunp syfunp) {
        syService.addFunc(syfunp);
        return new ResultBean();
    }

    @ApiOperation(value = "删除功能菜单")
    @RequestMapping(value = "/deleteFunc")
    public ResultBean deleteFunc(@RequestBody Syfunp syfunp) {
        syService.deleteFunc(syfunp);
        return new ResultBean();
    }

    @ApiOperation(value = "更新功能菜单")
    @RequestMapping(value = "/updateFunc")
    public ResultBean updateFunc(@RequestBody Syfunp[] syfunp) {
        syService.updateFunc(syfunp[0], syfunp[1]);
        return new ResultBean();
    }

    @ApiOperation(value = "添加功能菜单到工作组")
    @RequestMapping(value = "/addWorkGroupFunc")
    public ResultBean addWorkGroupFunc(@RequestBody List<Syifrp> syifrp) {
        syService.addWorkGroupFunc(syifrp);
        return new ResultBean();
    }

    @ApiOperation(value = "从工作组删除功能菜单")
    @RequestMapping(value = "/deleteWorkGroupFunc")
    public ResultBean deleteWorkGroupFunc(@RequestBody List<Syifrp> syifrp) {
        syService.deleteWorkGroupFunc(syifrp);
        return new ResultBean();
    }

    @ApiOperation(value = "获取综合编码类别列表")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "sort", value = "排序", required = false, paramType = "query", dataType = "Integer",defaultValue = "0"),
    })
    @RequestMapping(value = "/getZhbmlbList")
    public ResultBean getZhbmlbList(@RequestBody Map<String, Object> paramMap) {
        Integer sort = paramMap.get("sort") == null ? 0 : (Integer) paramMap.get("sort");
        return new ResultBean(syService.getZhbmlbList(sort));
    }

    @ApiOperation(value = "获取综合编码列表")
    @RequestMapping(value = "/getZhbmList")
    public ResultBean getZhbmList(@RequestBody Dm_zhbmlbp zhbmlbp) {
        return new ResultBean(syService.getZhbmList(zhbmlbp));
    }

    @ApiOperation(value = "添加综合编码")
    @RequestMapping(value = "/addZhbm")
    public ResultBean addZhbm(@RequestBody Dm_zhbmp zhbmp) {
        syService.addZhbm(zhbmp);
        return new ResultBean();
    }

    @ApiOperation(value = "删除综合编码")
    @RequestMapping(value = "/deleteZhbm")
    public ResultBean deleteZhbm(@RequestBody Dm_zhbmp zhbmp) {
        syService.deleteZhbm(zhbmp);
        return new ResultBean();
    }

    @ApiOperation(value = "更新综合编码")
    @RequestMapping(value = "/updateZhbm")
    public ResultBean updateZhbm(@RequestBody Dm_zhbmp[] zhbmp) {
        syService.updateZhbm(zhbmp[0], zhbmp[1]);
        return new ResultBean();
    }


    @ApiOperation(value = "获取综合编码列表")
    @RequestMapping(value = "/getZhbmAll")
    public ResultBean getZhbmAll() {
        List<Dm_zhbmp> zhbmList = syService.getALL();
        Map<String,List<Dm_zhbmp>> map=zhbmList.stream()
            .collect(Collectors.groupingBy(Dm_zhbmp::getBMLB));
        return new ResultBean(map);
    }

    @ApiOperation(value = "设备信息转码")
    @RequestMapping(value = "/emSbjbbZM")
    public ResultBean em_sbjbb_ZM(@RequestBody JSONObject json) {
        String bmlb=json.getString("bmlb");
        List<Map> dmZhbmp= syService.em_sbjbb_ZM(bmlb);
        return new ResultBean(dmZhbmp);
    }
    @RequestMapping(value = "/getSystemList")
    public ResultBean getSystemList(@RequestBody Map<String, Object> paramMap) {
        return new ResultBean(syService.getSystemList());
    }
    @RequestMapping(value = "/getMenuList")
    public ResultBean getMenuList(@RequestBody Map<String, Object> paramMap) {
        return new ResultBean(syService.getMenuList());
    }
    @RequestMapping(value = "/getMenuForRole")
    public ResultBean getMenuForRole(@RequestBody Map<String, Object> paramMap) {
        return new ResultBean(syService.getMenuForRole());
    }


    @RequestMapping(value = "/getUserListByMenu")
    public ResultBean getUserListByMenu(@RequestBody Map<String, Object> paramMap) {
        return new ResultBean(syService.getUserListByMenu(paramMap));
    }

    @RequestMapping(value = "/getDepartList")
    public ResultBean getDepartList() {
        return new ResultBean(syService.getDepartList());
    }

    @RequestMapping(value = "/getRoleList")
    public ResultBean getRoleList() {
        return new ResultBean(syService.getRoleList());
    }

    @RequestMapping(value = "/getRoleListByUser")
    public ResultBean getRoleListByUser(@RequestBody Map<String, Object> paramMap) {
        return new ResultBean(syService.getRoleListByUser((String) paramMap.get("yhdm")));
    }

    @RequestMapping(value = "/addRoleForUser")
    public ResultBean addRoleForUser(@RequestBody List<Map<String, Object>> paramList) {
        syService.addRoleForUser(paramList);
        return new ResultBean();
    }

    @RequestMapping(value = "/deleteRoleForUser")
    public ResultBean deleteRoleForUser(@RequestBody List<Map<String, Object>> paramList) {
        syService.deleteRoleForUser(paramList);
        return new ResultBean();
    }

    @RequestMapping(value = "/getInstitutionList")
    public ResultBean getInstitutionList(@RequestBody Map<String, Object> paramMap) {
        return new ResultBean(syService.getInstitutionList());
    }

    @RequestMapping(value = "/getUserListByRole")
    public ResultBean getUserListByRole(@RequestBody Map<String, Object> paramMap) {
        return new ResultBean(syService.getUserListByRole(paramMap.get("role_code").toString()));
    }

    @RequestMapping(value = "/getInstitutionListByRole")
    public ResultBean getInstitutionListByRole(@RequestBody Map<String, Object> paramMap) {
        return new ResultBean(syService.getInstitutionListByRole(paramMap.get("role_code").toString()));
    }

    @RequestMapping(value = "/getSystemListByRole")
    public ResultBean getSystemListByRole(@RequestBody Map<String, Object> paramMap) {
        return new ResultBean(syService.getSystemListByRole(paramMap.get("role_code").toString()));
    }

    @RequestMapping(value = "/getMenuListByRole")
    public ResultBean getMenuListByRole(@RequestBody Map<String, Object> paramMap) {
        return new ResultBean(syService.getMenuListByRole(paramMap.get("role_code").toString()));
    }


    @RequestMapping(value = "/addRole")
    public ResultBean addRole(@RequestBody Map role) {
        return new ResultBean(syService.addRole(role));
    }

    @RequestMapping(value = "/deleteRole")
    public ResultBean deleteRole(@RequestBody Map paramMap) {
        return new ResultBean(syService.deleteRole((String) paramMap.get("role_code")));
    }

    @RequestMapping(value = "/updateRole")
    public ResultBean updateRole(@RequestBody Map role) {
        return new ResultBean(syService.updateRole(role));
    }

    @RequestMapping(value = "/addRoleForInstitution")
    public ResultBean addRoleForInstitution(@RequestBody List<Map<String, Object>> paramList) {
        syService.addRoleForInstitution(paramList);
        return new ResultBean();
    }

    @RequestMapping(value = "/deleteRoleForInstitution")
    public ResultBean deleteRoleForInstitution(@RequestBody List<Map<String, Object>> paramList) {
        syService.deleteRoleForInstitution(paramList);
        return new ResultBean();
    }
    @RequestMapping(value = "/addRoleForSystem")
    public ResultBean addRoleForSystem(@RequestBody List<Map<String, Object>> paramList) {
        syService.addRoleForSystem(paramList);
        return new ResultBean();
    }

    @RequestMapping(value = "/deleteRoleForSystem")
    public ResultBean deleteRoleForSystem(@RequestBody List<Map<String, Object>> paramList) {
        syService.deleteRoleForSystem(paramList);
        return new ResultBean();
    }

    @RequestMapping(value = "/addRoleForMenu")
    public ResultBean addRoleForMenu(@RequestBody List<Map<String, Object>> paramList) {
        syService.addRoleForMenu(paramList);
        return new ResultBean();
    }

    @RequestMapping(value = "/deleteRoleForMenu")
    public ResultBean deleteRoleForMenu(@RequestBody List<Map<String, Object>> paramList) {
        syService.deleteRoleForMenu(paramList);
        return new ResultBean();
    }
}
