package com.dsic.gj_erp.pc;

import com.google.common.collect.ImmutableMap;
import lombok.AllArgsConstructor;
import lombok.Getter;

public interface Constant {
    //相对于钢料需求期
    ImmutableMap<工序, Integer> 工序CD = ImmutableMap.<工序, Integer>builder()
            .put(工序.上料, -14)
            .put(工序.抛丸, -12)
            .put(工序.理料, -11)
            .put(工序.划线, -9)
            .put(工序.切割, -7)
            .put(工序.坡口, -5)
            .put(工序.型材面板, -11)
            .put(工序.曲型, -5)
            .put(工序.打磨, -5)
            .put(工序.预配盘, -3)
            .put(工序.光电结束, -3)
            .put(工序.自由边处理,0)
            .put(工序.号料,0)
            .put(工序.倒棱,0)
            .put(工序.切端头,0)
            .put(工序.配送, 0)
            .put(工序.NULL, 0)
            .build();

    @Getter
    @AllArgsConstructor
    enum 设备产能{
        上料01(工序.上料,"上料01","",0,0,400.0,400.0,400),
        抛丸01(工序.抛丸,"抛丸01","",0,0,400.0,286.0,526.0),
        理料01(工序.理料,"理料01","",0,0,400.0,286.0,526.0),
        划线01(工序.划线,"划线01","",0,0,400.0,286.0,526.0),

        龙门01(工序.切割,"龙门01","",2.4,3.6,40,15.6,25.2),
        火焰01(工序.切割,"火焰01","",0.3,11.15,40.0,0,2.0),
        数控01(工序.切割,"数控01","",1.5,3.0,0,8.5,8.5),

        火焰02(工序.切割, "火焰02", "", 0.3, 11.5, 40.0, 0, 3.9),
        数控02(工序.切割, "数控02", "", 1.4, 3.0, 0, 18.2, 18.2),
        龙门02(工序.切割, "龙门02", "", 2.0, 3.0, 40.0, 13.0, 13.0),

        火焰03(工序.切割, "火焰03", "", 0.3, 11.5, 40.0, 0, 2.0),
        数控03(工序.切割, "数控03", "", 2.0, 4.2, 0, 14.0, 14.0),
        龙门03(工序.切割, "龙门03", "", 1.6, 3.2, 40.0, 11.2, 18.4),

        坡口01(工序.坡口, "坡口01", "", 2.0, 3.0, 100.0, 13.0, 13.0),
        型材01(工序.型材面板, "型材01", "", 2.0, 3.0, 100.0, 13.0, 13.0),
        曲加工01(工序.曲型, "曲加工01", "", 2.0, 3.0, 100.0, 13.0, 13.0),
        打磨01(工序.打磨, "打磨01", "", 2.0, 3.0, 0, 0, 0),

        自由边处理01(工序.自由边处理, "自由边处理01", "", 2.0, 3.0, 100.0, 13.0, 13.0),
        光电01(工序.光电结束, "光电01", "", 2.0, 3.0, 100.0, 13.0, 13.0),
        未知01(工序.NULL, "未知01", "", 2.0, 3.0, 100.0, 13.0, 13.0),
        ;
        public 工序 _工序;
        public String 设备编号;
        public String 设备名称;
        public double 单台效率;
        public double 单台产能;
        public double 白班设备产能;
        public double 二班设备产能;
        public double 双班合计产能;
    }

    @AllArgsConstructor
    enum 工序 {
        NULL(""),
        上料("19"),
        抛丸("20"),
        理料("21"),
        划线("01"),
        切割("03,04,05,06"),
        //一跨龙门切割("03"),一跨数控切割("04"),二跨数控切割("04"),三跨数控切割("04"),三跨平铁切割("05"),手工切割("06"),
        坡口("08"),
        型材面板("17"),
        自由边处理("14,15"),
        曲型("18"),
        打磨("13,16"),
        号料("02"),
        //平铁打磨("13"),手工打磨("16"),
        倒棱("09"),
        切端头("11"),
        预配盘(""),
        光电结束("66"),
        配送(""),

        ;

        @Getter
        private String code;

        //通过code获取工序
        public static 工序 getGxByCode(String code) {
            for (工序 gx : 工序.values()) {
                if (gx.getCode().contains(code)) {
                    return gx;
                }
            }
            return 工序.NULL;
        }

        //判断工序是否时NULL的
        public static boolean isNull(工序 gx) {
            return gx==工序.NULL;
        }
    }
}
